/*****************************************************************************
	ADC SPI
	Target	DE0-NANO
	Date		09/10/2014
	Designer	Calzo
 -----------------------------------------------------------------------------
 OBIETTIVI:
 ----------
 - realizzare la comunicazione SPI per collegarsi all'ADC
 - portare sui led la lettura dell'ADC
 OBIETTIVO SECONDARIO:
 ---------------------
 - Portare eventualmente il valore fuori con il vJTAG
 *****************************************************************************/

module main
(	input		CLOCK_50,			// 50 MHz
	output	ADC_SCLK,			// clock dell'SPI
	output	ADC_SADDR,			// data input dell'ADC
	output	ADC_CS_N,			// chip select
	input		ADC_SDAT,			// data out dell'ADC verso l'FPGA
	output	[7:0] LED);

reg [6:0] enable_cnt = 7'd0;
reg enable_cmd;

wire [15:0] data;

// creazione dei segnali per l'SPI
always @(posedge CLOCK_50)
begin
	enable_cnt <= enable_cnt + 1'd1;
	enable_cmd <= enable_cnt[6] && enable_cnt[5:0] < 4'hF;	// tengo alto il segnale per 16 colpi di clock
end
	
// Gestione dell'ADC e connessione con le uscite
SPI	spi0
(	.clk(CLOCK_50),
	.enable(enable_cmd),
	.SCLK(ADC_SCLK),
	.DOUT(ADC_SDAT),
	.DIN(ADC_SADDR),
	.CS(ADC_CS_N),
	.DATA(data));

// assegnazione dei led
assign LED = data[11:4];

endmodule
