/**************************************************************************************
 SHIFT REGISTER 01
 Top file
 Date	14/10/2014
 Target	DE0 NANO
 --------------------------------------------------------------------------------------
 OBIETTIVO:
 - Realizzare uno shift-register a 8 bit
 --------------------------------------------------------------------------------------
 NOTE IMPLEMENTATIVE:
 Si noti che i tasti KEY[1:0] sulla scheda DE0-NANO sono connesse in logica inversa.
 Siccome però il codice valuta i fronti di salita, questo aspetto è ininfluente.
 --------------------------------------------------------------------------------------
 RISULTATO:
 Funziona.
 --------------------------------------------------------------------------------------
 CONCUSIONE:
 --------------------------------------------------------------------------------------
 NOTA DI COMPILAZIONE:
 --------------------------------------------------------------------------------------
 PIN ASSIGMENTS:
 --------------------------------------------------------------------------------------
 TIME QUEST:
 **************************************************************************************/

module main
(	input		Key0,	// shift dei bit
	input		Key1,	// set a 1 del primo bit
	output		[7:0]LED);

reg [7:0] led = 8'h0;
wire key0, key1;

always @(posedge key0 or posedge key1)
begin
	if(key1)	// con "posedge", l'if deve essere vero con key=1; viceversa con "negedge"
		led[0] <= 1'b1;
	else
		led <= led << 1'b1;
end

assign key0 = ~Key0;	// equivalente in questo caso a !Key0
assign key1 = ~Key1;
assign LED = led;

endmodule
