/*******************************************************************
 SHIFT REGISTER:
 prende in ingresso il TDO dal vJTAG e separa i due numeri da 8 bit.
 In altre parole precarica nell'array dei dati... i dati ricevuti in
 modo seiale per esempio dal vJTAG.
 *******************************************************************/

module DataShifterIN(
	input	clk,
	input	vsdr,
	input	tdi,
	output	[SIZE-1:0] q);

parameter SIZE = 8;	
	
reg [SIZE-1:0] outcome = 16'd0;
	
always @(posedge clk)
begin
	if(vsdr)
		outcome <= {outcome[SIZE-2:0], tdi};
end


// idx[0] viene interpretato come un clock scrivendo questa assegnazione.
// Nel timequest però l'ho definito come clock e ho una 20ina di Warn.
// Credo che non devo usare "generate_clock", ma "set_clock_uncertainty"
// che però non so come si usa. Qualche esempio su come usarlo è qui:
//	http://www.csus.edu/indiv/p/pangj/274/handout/Handout_set_clock_uncertainty.txt
//assign q = idx == 4'd0 ? outcome : q;
assign q = outcome;

endmodule


module DataShifterOUT(
	input	clk,
	input	vsdr,
	input	[SIZE-1:0] data,
	output	tdo);

parameter SIZE = 8;
reg [SIZE:0] count;	// servirebbe il log
	
always @(posedge clk)
begin
	if(vsdr)
		count <= count + 1'd1;
	else
		count <= 8'd0;
end

assign tdo = data[count];

endmodule
