# In questo script è stata aggiunta la trasmissione dati verso il client QT ##################

##############################################################################################
############################# Basic vJTAG Interface ##########################################
##############################################################################################

#This portion of the script is derived from some of the examples from Altera

global usbblaster_name
global test_device
# List all available programming hardwares, and select the USBBlaster.
# (Note: this example assumes only one USBBlaster connected.)
# Programming Hardwares:
foreach hardware_name [get_hardware_names] {
#	puts $hardware_name
	if { [string match "USB-Blaster*" $hardware_name] } {
		set usbblaster_name $hardware_name
	}
}


puts "\nSelect JTAG chain connected to $usbblaster_name.\n";

# List all devices on the chain, and select the first device on the chain.
#Devices on the JTAG chain:


foreach device_name [get_device_names -hardware_name $usbblaster_name] {
#	puts $device_name
	if { [string match "@1*" $device_name] } {
		set test_device $device_name
	}
}
puts "\nSelect device: $test_device.\n";


# Open device 
proc openport {} {
	global usbblaster_name
        global test_device
	open_device -hardware_name $usbblaster_name -device_name $test_device
}


# Close device.  Just used if communication error occurs
proc closeport { } {
	catch {device_unlock}
	catch {close_device}
}


# Funzione di scrittura dell'"Instruction Register"
# -------------------------------------------------
proc set_IR {JTAG_cmd sock} {
	variable x

	openport   
	device_lock -timeout 10000
	
	# La stringa deve essere formattata come <IR DR>, esempio: <0x3F 0x0040A1>
	# Occorre quindi separare i campi
	
	# Calocolo la lunghezza totale
	set len [string length $JTAG_cmd]

	# Determino dove finisce il primo valore e dove comincia il secondo
	set idx [string wordend $JTAG_cmd 0]
	set w1_end [expr $idx-1]
	set w2_begin [expr $idx+3]

	# Determino il comando Instruction Register: non serve conoscere la dimensione
	set IR_cmd [string range $JTAG_cmd 0 $w1_end]

	#determino il comando Data Register: devo calcolare anche la lunghezza
	set DR_cmd [string range $JTAG_cmd $w2_begin $len]
	set DR_len [expr [string length $DR_cmd]*4]

## Evito di stampare perchè così è più veloce
##	puts "Writing - $send_data"

	# Cancellando l'istruzione "-no_captured_ir_value" riesco a leggere il registro IR_OUT inviato dall'FPGA
	device_virtual_ir_shift -instance_index 0 -ir_value $IR_cmd -no_captured_ir_value
	
## Evito di stampare perchè così è più veloce
##	puts "IR = $x"
	
	set x [device_virtual_dr_shift -dr_value $DR_cmd -instance_index 0  -length $DR_len -value_in_hex]

## Evito di stampare perchè così è più veloce
##	puts "DR = $x"
	
	# Set IR back to 0, which is bypass mode
#	device_virtual_ir_shift -instance_index 0 -ir_value 0 -no_captured_ir_value
  
	puts $sock $x

	closeport

	#return $tdi
}



##############################################################################################




##############################################################################################
################################# TCP/IP Server ##############################################
##############################################################################################

#Code Dervied from Tcl Developer Exchange - http://www.tcl.tk/about/netserver.html

proc Start_Server {port} {
	set s [socket -server ConnAccept $port]
	puts "Started Socket Server on port - $port"
	vwait forever
}

	
proc ConnAccept {sock addr port} {
    global conn

    # Record the client's information

    puts "Accept $sock from $addr port $port"
    set conn(addr,$sock) [list $addr $port]

    # Ensure that each "puts" by the server
    # results in a network transmission

    fconfigure $sock -buffering line

    # Set up a callback for when the client sends data

    fileevent $sock readable [list IncomingData $sock]
	
	puts $sock "\nRichiesta comandi esadecimali <IR> <DR>"
}


proc IncomingData {sock} {
    global conn

    # Check end of file or abnormal connection drop,
    # then write the data to the vJTAG

    if {[eof $sock] || [catch {gets $sock line}]} {
	close $sock
	puts "Close $conn(addr,$sock)"
	unset conn(addr,$sock)
    } else {
	#Before the connection is closed we get an emtpy data transmission. Let's check for it and trap it
	set data_len [string length $line]

	if {$data_len != "0"} then {
		# Nella versione originale si fermava ai primi 6 byte, ma qui invio tutto
		set_IR $line $sock
	}
	}
}

#Start this Server at Port 2540
Start_Server 2540

##############################################################################################

